Loading...
Searching...
No Matches
itk::GPUBSplineBaseTransform< TScalarType, NDimensions > Class Template Reference

`#include <itkGPUBSplineBaseTransform.h>`

## Detailed Description

template<typename TScalarType = float, unsigned int NDimensions = 3>
class itk::GPUBSplineBaseTransform< TScalarType, NDimensions >

GPU base class for the BSplineTransform.

Author
  Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands

Note
  This work was funded by the Netherlands Organisation for Scientific Research (NWO NRG-2010.02 and NWO 639.021.124).

Definition at line 42 of file itkGPUBSplineBaseTransform.h.

Inheritance diagram for itk::GPUBSplineBaseTransform< TScalarType, NDimensions >:
[legend]

## Public Types

using | GPUCoefficientImageArray = FixedArray<GPUCoefficientImagePointer, NDimensions>
using | GPUCoefficientImageBaseArray = FixedArray<GPUDataManagerPointer, NDimensions>
using | GPUCoefficientImagePointer = typename GPUCoefficientImageType::Pointer
using | GPUCoefficientImageType = GPUImage<TScalarType, NDimensions>
using | GPUDataManagerPointer = typename GPUDataManager::Pointer
using | Self = GPUBSplineBaseTransform
Public Types inherited from itk::GPUTransformBase
using | Self = GPUTransformBase

## Public Member Functions

virtual const char * | GetClassName () const
const GPUCoefficientImageArray | GetGPUCoefficientImages () const
const GPUCoefficientImageBaseArray | GetGPUCoefficientImagesBases () const
virtual unsigned int | GetSplineOrder () const
bool | IsBSplineTransform () const override
| itkStaticConstMacro (SpaceDimension, unsigned int, NDimensions)
Public Member Functions inherited from itk::GPUTransformBase
virtual const char * | GetNameOfClass () const
virtual GPUDataManager::Pointer | GetParametersDataManager () const
virtual GPUDataManager::Pointer | GetParametersDataManager (const std::vcl_size_t index) const
virtual bool | IsIdentityTransform () const
virtual bool | IsMatrixOffsetTransform () const
virtual bool | IsTranslationTransform () const

## Protected Member Functions

bool | GetSourceCode (std::string &source) const override
| GPUBSplineBaseTransform ()
virtual void | SetSplineOrder (const unsigned int splineOrder)
| ~GPUBSplineBaseTransform () override=default
Protected Member Functions inherited from itk::GPUTransformBase
| GPUTransformBase ()
virtual | ~GPUTransformBase ()=default

## Protected Attributes

GPUCoefficientImageArray | m_GPUBSplineTransformCoefficientImages {}
GPUCoefficientImageBaseArray | m_GPUBSplineTransformCoefficientImagesBase {}
Protected Attributes inherited from itk::GPUTransformBase
GPUDataManager::Pointer | m_ParametersDataManager {}

## Private Member Functions

| GPUBSplineBaseTransform (const Self &other)=delete
const Self & | operator= (const Self &)=delete

## Private Attributes

std::vector< std::string > | m_Sources {}
unsigned int | m_SplineOrder {}

## Member Typedef Documentation

## GPUCoefficientImageArray

template<typename TScalarType = float, unsigned int NDimensions = 3>

using itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUCoefficientImageArray = FixedArray<GPUCoefficientImagePointer, NDimensions>

Definition at line 62 of file itkGPUBSplineBaseTransform.h.

## GPUCoefficientImageBaseArray

template<typename TScalarType = float, unsigned int NDimensions = 3>

using itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUCoefficientImageBaseArray = FixedArray<GPUDataManagerPointer, NDimensions>

Definition at line 63 of file itkGPUBSplineBaseTransform.h.

## GPUCoefficientImagePointer

template<typename TScalarType = float, unsigned int NDimensions = 3>

using itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUCoefficientImagePointer = typename GPUCoefficientImageType::Pointer

Definition at line 59 of file itkGPUBSplineBaseTransform.h.

## GPUCoefficientImageType

template<typename TScalarType = float, unsigned int NDimensions = 3>

using itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUCoefficientImageType = GPUImage<TScalarType, NDimensions>

Definition at line 58 of file itkGPUBSplineBaseTransform.h.

## GPUDataManagerPointer

template<typename TScalarType = float, unsigned int NDimensions = 3>

using itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUDataManagerPointer = typename GPUDataManager::Pointer

Definition at line 60 of file itkGPUBSplineBaseTransform.h.

## Self

template<typename TScalarType = float, unsigned int NDimensions = 3>

using itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::Self = GPUBSplineBaseTransform

Standard class typedefs.

Definition at line 46 of file itkGPUBSplineBaseTransform.h.

## Constructor & Destructor Documentation

## GPUBSplineBaseTransform() [1/2]

template<typename TScalarType = float, unsigned int NDimensions = 3>

itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUBSplineBaseTransform | ( |  | ) |

protected

## ~GPUBSplineBaseTransform()

template<typename TScalarType = float, unsigned int NDimensions = 3>

itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::~GPUBSplineBaseTransform | ( |  | ) |

override protected default

## GPUBSplineBaseTransform() [2/2]

template<typename TScalarType = float, unsigned int NDimensions = 3>

itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GPUBSplineBaseTransform | ( | const Self & | other | ) |

private delete

## Member Function Documentation

## GetClassName()

template<typename TScalarType = float, unsigned int NDimensions = 3>

virtual const char * itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in itk::GPUAdvancedBSplineDeformableTransform< TScalarType, NDimensions, VSplineOrder, TParentTransform >, and itk::GPUBSplineTransform< TScalarType, NDimensions, VSplineOrder, TParentTransform >.

## GetGPUCoefficientImages()

template<typename TScalarType = float, unsigned int NDimensions = 3>

const GPUCoefficientImageArray itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GetGPUCoefficientImages | ( |  | ) | const

Get the GPU array of coefficient images.

## GetGPUCoefficientImagesBases()

template<typename TScalarType = float, unsigned int NDimensions = 3>

const GPUCoefficientImageBaseArray itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GetGPUCoefficientImagesBases | ( |  | ) | const

Get the GPU array of coefficient images bases.

## GetSourceCode()

template<typename TScalarType = float, unsigned int NDimensions = 3>

bool itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GetSourceCode | ( | std::string & | source | ) | const

override protected virtual

Returns OpenCL source code for the transform. Returns true if source code was combined, false otherwise.

Reimplemented from itk::GPUTransformBase.

## GetSplineOrder()

template<typename TScalarType = float, unsigned int NDimensions = 3>

virtual unsigned int itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::GetSplineOrder | ( |  | ) | const

virtual

Get the Spline Order, supports 0th - 3th order splines. The default is a 3rd order spline.

## IsBSplineTransform()

template<typename TScalarType = float, unsigned int NDimensions = 3>

bool itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::IsBSplineTransform | ( |  | ) | const

inline override virtual

Returns true, the transform is BSpline transform.

Reimplemented from itk::GPUTransformBase.

Definition at line 67 of file itkGPUBSplineBaseTransform.h.

## itkStaticConstMacro()

template<typename TScalarType = float, unsigned int NDimensions = 3>

itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::itkStaticConstMacro | ( | SpaceDimension | ,
|  | unsigned int | ,
|  | NDimensions | )

Dimension of the domain space.

## operator=()

template<typename TScalarType = float, unsigned int NDimensions = 3>

const Self & itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::operator= | ( | const Self & |  | ) |

private delete

## SetSplineOrder()

template<typename TScalarType = float, unsigned int NDimensions = 3>

virtual void itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::SetSplineOrder | ( | const unsigned int | splineOrder | ) |

protected virtual

Sets the Spline Order, supports 0th - 3th order splines. The default is a 3rd order spline. Should be protected method. In ITK design the BSpline order is a template parameter of the

See also
  BSplineBaseTransform. We don't want the same definition in GPUBSplineBaseTransform. Instead the derived class should call SetSplineOrder() in the constructor.

## Field Documentation

## m_GPUBSplineTransformCoefficientImages

template<typename TScalarType = float, unsigned int NDimensions = 3>

GPUCoefficientImageArray itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::m_GPUBSplineTransformCoefficientImages {}

protected

Definition at line 98 of file itkGPUBSplineBaseTransform.h.

## m_GPUBSplineTransformCoefficientImagesBase

template<typename TScalarType = float, unsigned int NDimensions = 3>

GPUCoefficientImageBaseArray itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::m_GPUBSplineTransformCoefficientImagesBase {}

protected

Definition at line 99 of file itkGPUBSplineBaseTransform.h.

## m_Sources

template<typename TScalarType = float, unsigned int NDimensions = 3>

std::vector<std::string> itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::m_Sources {}

private

Definition at line 106 of file itkGPUBSplineBaseTransform.h.

## m_SplineOrder

template<typename TScalarType = float, unsigned int NDimensions = 3>

unsigned int itk::GPUBSplineBaseTransform< TScalarType, NDimensions >::m_SplineOrder {}

private

Definition at line 109 of file itkGPUBSplineBaseTransform.h.

Generated on 1768596610 for elastix by 1.15.0 |